# React Filter Control
A React component which helps creating the complex filter criteria in the UI of React applications

## Overview
[image with fb]

## Installation
npm
```sh
npm install react-data-grid
```
yarn
```sh
yarn add react-data-grid
```

## Usage
A basic example:
```js
import React from 'react';
import ReactDOM from 'react-dom';
import FilterControl from "react-filter-control";

const operators = [{
  name: "=",
  caption: "Equals"
}, {
  name: "<>",
  caption: "Doesn't equal"
}];
const fields = [{
  name: "field1",
  caption: "Field 1",
  operators: operators,
}, {
  name: "field2",
  caption: "Field 2",
  operators: operators,
}];

const handleFilterValueChange = (filterValue) => {
  // ...
}

function App = () => {
  return (
    <FilterControl
      fields={fields}
      onFilterValueChanged={handleFilterValueChange} />
  );
}

ReactDOM.render(<App />, document.querySelector('#app'));
```