(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('react')) :
  typeof define === 'function' && define.amd ? define(['react'], factory) :
  (global['react-filter-control'] = factory(global.React));
}(this, (function (React) { 'use strict';

  var React__default = 'default' in React ? React['default'] : React;

  function styleInject(css, ref) {
    if ( ref === void 0 ) ref = {};
    var insertAt = ref.insertAt;

    if (!css || typeof document === 'undefined') { return; }

    var head = document.head || document.getElementsByTagName('head')[0];
    var style = document.createElement('style');
    style.type = 'text/css';

    if (insertAt === 'top') {
      if (head.firstChild) {
        head.insertBefore(style, head.firstChild);
      } else {
        head.appendChild(style);
      }
    } else {
      head.appendChild(style);
    }

    if (style.styleSheet) {
      style.styleSheet.cssText = css;
    } else {
      style.appendChild(document.createTextNode(css));
    }
  }

  var css = ".fc {\n    font-family: \"Helvetica Neue\",Helvetica,\"Segoe UI\",Verdana,\"san-serif\";\n}\n.fc-dropdownmenu-button {\n    margin-right: 3px;\n    margin-top: 3px;\n}\n.fc-dropdownmenu-contextmenu {\n    position: fixed;\n    background-color: white;\n    z-index: 20002;\n    padding: 5px;\n    box-shadow: 0 1px 10px #0005;\n}\n.fc-dropdownmenu-contextmenu-item {\n    padding: 5px;\n    cursor: pointer;\n}\n.fc-dropdownmenu-contextmenu-background {\n    position: fixed;\n    width: 100%;\n    height: 100%;\n    z-index: -1;\n    left: 0;\n    top: 0;\n}\n.fc-dropdownmenu-button {\n    padding: 7px 10px;\n    opacity: .8;\n    cursor: pointer;\n}\n.fc-dropdownmenu-button:hover {\n    opacity: 1;\n}\n.fc-button-color-secondary {\n    color: blue;\n}\n.fc-button-color-primary {\n    color: blue;\n}\n.fc-group-settings-row {\n    display: flex;\n}\n.fc-button-add:before {\n    margin: 3px;\n    width: 30px;\n    height: 30px;\n    content: '+';\n    font-size: 26px;\n    display: inline-flex;\n    flex-direction: column;\n    justify-content: center;\n    text-align: center;\n    color: green;\n    cursor: pointer;\n}\n.fc-button-remove:before {\n    margin: 3px;\n    width: 30px;\n    height: 30px;\n    content: '\\00d7';\n    font-size: 26px;\n    display: inline-flex;\n    flex-direction: column;\n    justify-content: center;\n    text-align: center;\n    color: red;\n    cursor: pointer;\n}\n.fc-value-editor {\n    margin: 3px;\n    padding: 0 3px;\n}";
  styleInject(css);

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  /*
  object-assign
  (c) Sindre Sorhus
  @license MIT
  */
  /* eslint-disable no-unused-vars */
  var getOwnPropertySymbols = Object.getOwnPropertySymbols;
  var hasOwnProperty = Object.prototype.hasOwnProperty;
  var propIsEnumerable = Object.prototype.propertyIsEnumerable;

  function toObject(val) {
  	if (val === null || val === undefined) {
  		throw new TypeError('Object.assign cannot be called with null or undefined');
  	}

  	return Object(val);
  }

  function shouldUseNative() {
  	try {
  		if (!Object.assign) {
  			return false;
  		}

  		// Detect buggy property enumeration order in older V8 versions.

  		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
  		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
  		test1[5] = 'de';
  		if (Object.getOwnPropertyNames(test1)[0] === '5') {
  			return false;
  		}

  		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
  		var test2 = {};
  		for (var i = 0; i < 10; i++) {
  			test2['_' + String.fromCharCode(i)] = i;
  		}
  		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
  			return test2[n];
  		});
  		if (order2.join('') !== '0123456789') {
  			return false;
  		}

  		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
  		var test3 = {};
  		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
  			test3[letter] = letter;
  		});
  		if (Object.keys(Object.assign({}, test3)).join('') !==
  				'abcdefghijklmnopqrst') {
  			return false;
  		}

  		return true;
  	} catch (err) {
  		// We don't expect any of the above to throw, but better to be safe.
  		return false;
  	}
  }

  var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
  	var from;
  	var to = toObject(target);
  	var symbols;

  	for (var s = 1; s < arguments.length; s++) {
  		from = Object(arguments[s]);

  		for (var key in from) {
  			if (hasOwnProperty.call(from, key)) {
  				to[key] = from[key];
  			}
  		}

  		if (getOwnPropertySymbols) {
  			symbols = getOwnPropertySymbols(from);
  			for (var i = 0; i < symbols.length; i++) {
  				if (propIsEnumerable.call(from, symbols[i])) {
  					to[symbols[i]] = from[symbols[i]];
  				}
  			}
  		}
  	}

  	return to;
  };

  /**
   * Copyright (c) 2013-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

  var ReactPropTypesSecret_1 = ReactPropTypesSecret;

  var printWarning = function() {};

  if (process.env.NODE_ENV !== 'production') {
    var ReactPropTypesSecret$1 = ReactPropTypesSecret_1;
    var loggedTypeFailures = {};

    printWarning = function(text) {
      var message = 'Warning: ' + text;
      if (typeof console !== 'undefined') {
        console.error(message);
      }
      try {
        // --- Welcome to debugging React ---
        // This error was thrown as a convenience so that you can use this stack
        // to find the callsite that caused this warning to fire.
        throw new Error(message);
      } catch (x) {}
    };
  }

  /**
   * Assert that the values match with the type specs.
   * Error messages are memorized and will only be shown once.
   *
   * @param {object} typeSpecs Map of name to a ReactPropType
   * @param {object} values Runtime values that need to be type-checked
   * @param {string} location e.g. "prop", "context", "child context"
   * @param {string} componentName Name of the component for error messages.
   * @param {?Function} getStack Returns the component stack.
   * @private
   */
  function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
    if (process.env.NODE_ENV !== 'production') {
      for (var typeSpecName in typeSpecs) {
        if (typeSpecs.hasOwnProperty(typeSpecName)) {
          var error;
          // Prop type validation may throw. In case they do, we don't want to
          // fail the render phase where it didn't fail before. So we log it.
          // After these have been cleaned up, we'll let them throw.
          try {
            // This is intentionally an invariant that gets caught. It's the same
            // behavior as without this statement except with a better message.
            if (typeof typeSpecs[typeSpecName] !== 'function') {
              var err = Error(
                (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
                'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.'
              );
              err.name = 'Invariant Violation';
              throw err;
            }
            error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret$1);
          } catch (ex) {
            error = ex;
          }
          if (error && !(error instanceof Error)) {
            printWarning(
              (componentName || 'React class') + ': type specification of ' +
              location + ' `' + typeSpecName + '` is invalid; the type checker ' +
              'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
              'You may have forgotten to pass an argument to the type checker ' +
              'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
              'shape all require an argument).'
            );

          }
          if (error instanceof Error && !(error.message in loggedTypeFailures)) {
            // Only monitor this failure once because there tends to be a lot of the
            // same error.
            loggedTypeFailures[error.message] = true;

            var stack = getStack ? getStack() : '';

            printWarning(
              'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
            );
          }
        }
      }
    }
  }

  var checkPropTypes_1 = checkPropTypes;

  var printWarning$1 = function() {};

  if (process.env.NODE_ENV !== 'production') {
    printWarning$1 = function(text) {
      var message = 'Warning: ' + text;
      if (typeof console !== 'undefined') {
        console.error(message);
      }
      try {
        // --- Welcome to debugging React ---
        // This error was thrown as a convenience so that you can use this stack
        // to find the callsite that caused this warning to fire.
        throw new Error(message);
      } catch (x) {}
    };
  }

  function emptyFunctionThatReturnsNull() {
    return null;
  }

  var factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
    /* global Symbol */
    var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
    var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

    /**
     * Returns the iterator method function contained on the iterable object.
     *
     * Be sure to invoke the function with the iterable as context:
     *
     *     var iteratorFn = getIteratorFn(myIterable);
     *     if (iteratorFn) {
     *       var iterator = iteratorFn.call(myIterable);
     *       ...
     *     }
     *
     * @param {?object} maybeIterable
     * @return {?function}
     */
    function getIteratorFn(maybeIterable) {
      var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
      if (typeof iteratorFn === 'function') {
        return iteratorFn;
      }
    }

    /**
     * Collection of methods that allow declaration and validation of props that are
     * supplied to React components. Example usage:
     *
     *   var Props = require('ReactPropTypes');
     *   var MyArticle = React.createClass({
     *     propTypes: {
     *       // An optional string prop named "description".
     *       description: Props.string,
     *
     *       // A required enum prop named "category".
     *       category: Props.oneOf(['News','Photos']).isRequired,
     *
     *       // A prop named "dialog" that requires an instance of Dialog.
     *       dialog: Props.instanceOf(Dialog).isRequired
     *     },
     *     render: function() { ... }
     *   });
     *
     * A more formal specification of how these methods are used:
     *
     *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
     *   decl := ReactPropTypes.{type}(.isRequired)?
     *
     * Each and every declaration produces a function with the same signature. This
     * allows the creation of custom validation functions. For example:
     *
     *  var MyLink = React.createClass({
     *    propTypes: {
     *      // An optional string or URI prop named "href".
     *      href: function(props, propName, componentName) {
     *        var propValue = props[propName];
     *        if (propValue != null && typeof propValue !== 'string' &&
     *            !(propValue instanceof URI)) {
     *          return new Error(
     *            'Expected a string or an URI for ' + propName + ' in ' +
     *            componentName
     *          );
     *        }
     *      }
     *    },
     *    render: function() {...}
     *  });
     *
     * @internal
     */

    var ANONYMOUS = '<<anonymous>>';

    // Important!
    // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
    var ReactPropTypes = {
      array: createPrimitiveTypeChecker('array'),
      bool: createPrimitiveTypeChecker('boolean'),
      func: createPrimitiveTypeChecker('function'),
      number: createPrimitiveTypeChecker('number'),
      object: createPrimitiveTypeChecker('object'),
      string: createPrimitiveTypeChecker('string'),
      symbol: createPrimitiveTypeChecker('symbol'),

      any: createAnyTypeChecker(),
      arrayOf: createArrayOfTypeChecker,
      element: createElementTypeChecker(),
      instanceOf: createInstanceTypeChecker,
      node: createNodeChecker(),
      objectOf: createObjectOfTypeChecker,
      oneOf: createEnumTypeChecker,
      oneOfType: createUnionTypeChecker,
      shape: createShapeTypeChecker,
      exact: createStrictShapeTypeChecker,
    };

    /**
     * inlined Object.is polyfill to avoid requiring consumers ship their own
     * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
     */
    /*eslint-disable no-self-compare*/
    function is(x, y) {
      // SameValue algorithm
      if (x === y) {
        // Steps 1-5, 7-10
        // Steps 6.b-6.e: +0 != -0
        return x !== 0 || 1 / x === 1 / y;
      } else {
        // Step 6.a: NaN == NaN
        return x !== x && y !== y;
      }
    }
    /*eslint-enable no-self-compare*/

    /**
     * We use an Error-like object for backward compatibility as people may call
     * PropTypes directly and inspect their output. However, we don't use real
     * Errors anymore. We don't inspect their stack anyway, and creating them
     * is prohibitively expensive if they are created too often, such as what
     * happens in oneOfType() for any type before the one that matched.
     */
    function PropTypeError(message) {
      this.message = message;
      this.stack = '';
    }
    // Make `instanceof Error` still work for returned errors.
    PropTypeError.prototype = Error.prototype;

    function createChainableTypeChecker(validate) {
      if (process.env.NODE_ENV !== 'production') {
        var manualPropTypeCallCache = {};
        var manualPropTypeWarningCount = 0;
      }
      function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
        componentName = componentName || ANONYMOUS;
        propFullName = propFullName || propName;

        if (secret !== ReactPropTypesSecret_1) {
          if (throwOnDirectAccess) {
            // New behavior only for users of `prop-types` package
            var err = new Error(
              'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
              'Use `PropTypes.checkPropTypes()` to call them. ' +
              'Read more at http://fb.me/use-check-prop-types'
            );
            err.name = 'Invariant Violation';
            throw err;
          } else if (process.env.NODE_ENV !== 'production' && typeof console !== 'undefined') {
            // Old behavior for people using React.PropTypes
            var cacheKey = componentName + ':' + propName;
            if (
              !manualPropTypeCallCache[cacheKey] &&
              // Avoid spamming the console because they are often not actionable except for lib authors
              manualPropTypeWarningCount < 3
            ) {
              printWarning$1(
                'You are manually calling a React.PropTypes validation ' +
                'function for the `' + propFullName + '` prop on `' + componentName  + '`. This is deprecated ' +
                'and will throw in the standalone `prop-types` package. ' +
                'You may be seeing this warning due to a third-party PropTypes ' +
                'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
              );
              manualPropTypeCallCache[cacheKey] = true;
              manualPropTypeWarningCount++;
            }
          }
        }
        if (props[propName] == null) {
          if (isRequired) {
            if (props[propName] === null) {
              return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
            }
            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
          }
          return null;
        } else {
          return validate(props, propName, componentName, location, propFullName);
        }
      }

      var chainedCheckType = checkType.bind(null, false);
      chainedCheckType.isRequired = checkType.bind(null, true);

      return chainedCheckType;
    }

    function createPrimitiveTypeChecker(expectedType) {
      function validate(props, propName, componentName, location, propFullName, secret) {
        var propValue = props[propName];
        var propType = getPropType(propValue);
        if (propType !== expectedType) {
          // `propValue` being instance of, say, date/regexp, pass the 'object'
          // check, but we can offer a more precise error message here rather than
          // 'of type `object`'.
          var preciseType = getPreciseType(propValue);

          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createAnyTypeChecker() {
      return createChainableTypeChecker(emptyFunctionThatReturnsNull);
    }

    function createArrayOfTypeChecker(typeChecker) {
      function validate(props, propName, componentName, location, propFullName) {
        if (typeof typeChecker !== 'function') {
          return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
        }
        var propValue = props[propName];
        if (!Array.isArray(propValue)) {
          var propType = getPropType(propValue);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
        }
        for (var i = 0; i < propValue.length; i++) {
          var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);
          if (error instanceof Error) {
            return error;
          }
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createElementTypeChecker() {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        if (!isValidElement(propValue)) {
          var propType = getPropType(propValue);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createInstanceTypeChecker(expectedClass) {
      function validate(props, propName, componentName, location, propFullName) {
        if (!(props[propName] instanceof expectedClass)) {
          var expectedClassName = expectedClass.name || ANONYMOUS;
          var actualClassName = getClassName(props[propName]);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createEnumTypeChecker(expectedValues) {
      if (!Array.isArray(expectedValues)) {
        process.env.NODE_ENV !== 'production' ? printWarning$1('Invalid argument supplied to oneOf, expected an instance of array.') : void 0;
        return emptyFunctionThatReturnsNull;
      }

      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        for (var i = 0; i < expectedValues.length; i++) {
          if (is(propValue, expectedValues[i])) {
            return null;
          }
        }

        var valuesString = JSON.stringify(expectedValues);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + propValue + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
      }
      return createChainableTypeChecker(validate);
    }

    function createObjectOfTypeChecker(typeChecker) {
      function validate(props, propName, componentName, location, propFullName) {
        if (typeof typeChecker !== 'function') {
          return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
        }
        var propValue = props[propName];
        var propType = getPropType(propValue);
        if (propType !== 'object') {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
        }
        for (var key in propValue) {
          if (propValue.hasOwnProperty(key)) {
            var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
            if (error instanceof Error) {
              return error;
            }
          }
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createUnionTypeChecker(arrayOfTypeCheckers) {
      if (!Array.isArray(arrayOfTypeCheckers)) {
        process.env.NODE_ENV !== 'production' ? printWarning$1('Invalid argument supplied to oneOfType, expected an instance of array.') : void 0;
        return emptyFunctionThatReturnsNull;
      }

      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
        var checker = arrayOfTypeCheckers[i];
        if (typeof checker !== 'function') {
          printWarning$1(
            'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
            'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
          );
          return emptyFunctionThatReturnsNull;
        }
      }

      function validate(props, propName, componentName, location, propFullName) {
        for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
          var checker = arrayOfTypeCheckers[i];
          if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
            return null;
          }
        }

        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
      }
      return createChainableTypeChecker(validate);
    }

    function createNodeChecker() {
      function validate(props, propName, componentName, location, propFullName) {
        if (!isNode(props[propName])) {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createShapeTypeChecker(shapeTypes) {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        var propType = getPropType(propValue);
        if (propType !== 'object') {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
        }
        for (var key in shapeTypes) {
          var checker = shapeTypes[key];
          if (!checker) {
            continue;
          }
          var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error) {
            return error;
          }
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createStrictShapeTypeChecker(shapeTypes) {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        var propType = getPropType(propValue);
        if (propType !== 'object') {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
        }
        // We need to check all keys in case some are required but missing from
        // props.
        var allKeys = objectAssign({}, props[propName], shapeTypes);
        for (var key in allKeys) {
          var checker = shapeTypes[key];
          if (!checker) {
            return new PropTypeError(
              'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
              '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
              '\nValid keys: ' +  JSON.stringify(Object.keys(shapeTypes), null, '  ')
            );
          }
          var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error) {
            return error;
          }
        }
        return null;
      }

      return createChainableTypeChecker(validate);
    }

    function isNode(propValue) {
      switch (typeof propValue) {
        case 'number':
        case 'string':
        case 'undefined':
          return true;
        case 'boolean':
          return !propValue;
        case 'object':
          if (Array.isArray(propValue)) {
            return propValue.every(isNode);
          }
          if (propValue === null || isValidElement(propValue)) {
            return true;
          }

          var iteratorFn = getIteratorFn(propValue);
          if (iteratorFn) {
            var iterator = iteratorFn.call(propValue);
            var step;
            if (iteratorFn !== propValue.entries) {
              while (!(step = iterator.next()).done) {
                if (!isNode(step.value)) {
                  return false;
                }
              }
            } else {
              // Iterator will provide entry [k,v] tuples rather than values.
              while (!(step = iterator.next()).done) {
                var entry = step.value;
                if (entry) {
                  if (!isNode(entry[1])) {
                    return false;
                  }
                }
              }
            }
          } else {
            return false;
          }

          return true;
        default:
          return false;
      }
    }

    function isSymbol(propType, propValue) {
      // Native Symbol.
      if (propType === 'symbol') {
        return true;
      }

      // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
      if (propValue['@@toStringTag'] === 'Symbol') {
        return true;
      }

      // Fallback for non-spec compliant Symbols which are polyfilled.
      if (typeof Symbol === 'function' && propValue instanceof Symbol) {
        return true;
      }

      return false;
    }

    // Equivalent of `typeof` but with special handling for array and regexp.
    function getPropType(propValue) {
      var propType = typeof propValue;
      if (Array.isArray(propValue)) {
        return 'array';
      }
      if (propValue instanceof RegExp) {
        // Old webkits (at least until Android 4.0) return 'function' rather than
        // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
        // passes PropTypes.object.
        return 'object';
      }
      if (isSymbol(propType, propValue)) {
        return 'symbol';
      }
      return propType;
    }

    // This handles more types than `getPropType`. Only used for error messages.
    // See `createPrimitiveTypeChecker`.
    function getPreciseType(propValue) {
      if (typeof propValue === 'undefined' || propValue === null) {
        return '' + propValue;
      }
      var propType = getPropType(propValue);
      if (propType === 'object') {
        if (propValue instanceof Date) {
          return 'date';
        } else if (propValue instanceof RegExp) {
          return 'regexp';
        }
      }
      return propType;
    }

    // Returns a string that is postfixed to a warning about an invalid type.
    // For example, "undefined" or "of type array"
    function getPostfixForTypeWarning(value) {
      var type = getPreciseType(value);
      switch (type) {
        case 'array':
        case 'object':
          return 'an ' + type;
        case 'boolean':
        case 'date':
        case 'regexp':
          return 'a ' + type;
        default:
          return type;
      }
    }

    // Returns class name of the object, if any.
    function getClassName(propValue) {
      if (!propValue.constructor || !propValue.constructor.name) {
        return ANONYMOUS;
      }
      return propValue.constructor.name;
    }

    ReactPropTypes.checkPropTypes = checkPropTypes_1;
    ReactPropTypes.PropTypes = ReactPropTypes;

    return ReactPropTypes;
  };

  function emptyFunction() {}

  var factoryWithThrowingShims = function() {
    function shim(props, propName, componentName, location, propFullName, secret) {
      if (secret === ReactPropTypesSecret_1) {
        // It is still safe when called from React.
        return;
      }
      var err = new Error(
        'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
        'Use PropTypes.checkPropTypes() to call them. ' +
        'Read more at http://fb.me/use-check-prop-types'
      );
      err.name = 'Invariant Violation';
      throw err;
    }  shim.isRequired = shim;
    function getShim() {
      return shim;
    }  // Important!
    // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
    var ReactPropTypes = {
      array: shim,
      bool: shim,
      func: shim,
      number: shim,
      object: shim,
      string: shim,
      symbol: shim,

      any: shim,
      arrayOf: getShim,
      element: shim,
      instanceOf: getShim,
      node: shim,
      objectOf: getShim,
      oneOf: getShim,
      oneOfType: getShim,
      shape: getShim,
      exact: getShim
    };

    ReactPropTypes.checkPropTypes = emptyFunction;
    ReactPropTypes.PropTypes = ReactPropTypes;

    return ReactPropTypes;
  };

  var propTypes = createCommonjsModule(function (module) {
  /**
   * Copyright (c) 2013-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  if (process.env.NODE_ENV !== 'production') {
    var REACT_ELEMENT_TYPE = (typeof Symbol === 'function' &&
      Symbol.for &&
      Symbol.for('react.element')) ||
      0xeac7;

    var isValidElement = function(object) {
      return typeof object === 'object' &&
        object !== null &&
        object.$$typeof === REACT_ELEMENT_TYPE;
    };

    // By explicitly using `prop-types` you are opting into new development behavior.
    // http://fb.me/prop-types-in-prod
    var throwOnDirectAccess = true;
    module.exports = factoryWithTypeCheckers(isValidElement, throwOnDirectAccess);
  } else {
    // By explicitly using `prop-types` you are opting into new production behavior.
    // http://fb.me/prop-types-in-prod
    module.exports = factoryWithThrowingShims();
  }
  });
  var propTypes_1 = propTypes.PropTypes;

  const AddButton = ({
    onClick
  }) => React__default.createElement("div", null, React__default.createElement("div", {
    className: "fc-group-button-icon fc-button-add",
    onClick: onClick,
    onKeyDown: onClick,
    tabIndex: "0",
    "aria-label": "Add",
    role: "button"
  }));

  AddButton.propTypes = {
    onClick: propTypes.func
  };
  AddButton.defaultProps = {
    onClick: undefined
  };

  const RemoveButton = ({
    onClick
  }) => React__default.createElement("div", {
    className: "fc-group-button-icon fc-button-remove",
    onClick: onClick,
    onKeyDown: onClick,
    tabIndex: "0",
    "aria-label": "Remove",
    role: "button"
  });

  RemoveButton.propTypes = {
    onClick: propTypes.func.isRequired
  };

  const Button = ({
    text,
    color,
    onClick
  }) => React__default.createElement("div", {
    className: `fc-dropdownmenu-button fc-button-color-${color || 'default'}`,
    "aria-haspopup": "true",
    onClick: onClick,
    onKeyDown: onClick,
    tabIndex: "0",
    role: "button"
  }, React__default.createElement("span", null, text));

  Button.propTypes = {
    text: propTypes.string,
    color: propTypes.string,
    onClick: propTypes.func.isRequired
  };
  Button.defaultProps = {
    text: '',
    color: ''
  };

  const Input = ({
    value,
    onChange
  }) => React__default.createElement("input", {
    value: value,
    onChange: onChange,
    className: "fc-value-editor"
  });

  Input.propTypes = {
    value: propTypes.string.isRequired,
    onChange: propTypes.func.isRequired
  };

  const Menu = ({
    visible,
    handleClose,
    menuItems,
    handleMenuItemClick,
    textField,
    keyField,
    activeIndex
  }) => visible ? React__default.createElement("div", {
    className: "fc-dropdownmenu-contextmenu"
  }, menuItems.map((item, index) => {
    const onClick = () => handleMenuItemClick(index);

    return React__default.createElement("div", {
      className: "fc-dropdownmenu-contextmenu-item",
      key: keyField ? item[keyField] : index,
      selected: index === activeIndex,
      onClick: onClick,
      onKeyDown: onClick,
      tabIndex: "0",
      role: "button"
    }, textField ? item[textField] : item);
  }), React__default.createElement("div", {
    className: "fc-dropdownmenu-contextmenu-background",
    onClick: handleClose,
    onKeyDown: handleClose,
    role: "button",
    tabIndex: "0"
  })) : React__default.createElement("div", null);

  Menu.propTypes = {
    visible: propTypes.bool,
    handleClose: propTypes.func,
    menuItems: propTypes.arrayOf(propTypes.any).isRequired,
    handleMenuItemClick: propTypes.func,
    textField: propTypes.string,
    keyField: propTypes.string,
    activeIndex: propTypes.number
  };
  Menu.defaultProps = {
    visible: false,
    handleClose: undefined,
    handleMenuItemClick: undefined,
    textField: '',
    keyField: '',
    activeIndex: 0
  };
  const FCContext = React__default.createContext({
    AddButton,
    RemoveButton,
    Button,
    Input,
    Menu
  });
  const {
    Consumer
  } = FCContext;

  class DropDownMenu extends React.Component {
    constructor(props) {
      super(props);
      this.state = {
        anchorEl: null
      };
      this.handleButtonClick = this.handleButtonClick.bind(this);
      this.handleMenuItemClick = this.handleMenuItemClick.bind(this);
      this.handleClose = this.handleClose.bind(this);
    }

    handleButtonClick(event) {
      this.setState({
        anchorEl: event.currentTarget
      });
    }

    handleMenuItemClick(index) {
      const {
        menuItems,
        keyField,
        onMenuItemClick
      } = this.props;
      const selected = menuItems[index];
      onMenuItemClick(keyField ? selected[keyField] : selected);
      this.setState({
        anchorEl: null
      });
    }

    handleClose() {
      this.setState({
        anchorEl: null
      });
    }

    renderButton(children) {
      return React__default.Children.map(children, child => React__default.cloneElement(child, {
        onClick: this.handleButtonClick
      }));
    }

    render() {
      const {
        activeIndex,
        color,
        menuItems,
        textField,
        keyField,
        children
      } = this.props;
      const {
        anchorEl
      } = this.state;
      return React__default.createElement("span", {
        className: "fc-dropdownmenu"
      }, children ? this.renderButton(children) : React__default.createElement(Consumer, null, value => React__default.createElement(value.Button, {
        text: textField ? menuItems[activeIndex][textField] : menuItems[activeIndex],
        color: color,
        onClick: this.handleButtonClick
      })), React__default.createElement(Consumer, null, value => React__default.createElement(value.Menu, {
        handleMenuItemClick: this.handleMenuItemClick,
        handleClose: this.handleClose,
        visible: anchorEl != null,
        menuItems: menuItems,
        textField: textField,
        keyField: keyField,
        activeIndex: activeIndex
      })));
    }

  }

  DropDownMenu.propTypes = {
    activeIndex: propTypes.number,
    color: propTypes.string,
    menuItems: propTypes.arrayOf(propTypes.any).isRequired,
    onMenuItemClick: propTypes.func.isRequired,
    textField: propTypes.string,
    keyField: propTypes.string,
    children: propTypes.node
  };
  DropDownMenu.defaultProps = {
    activeIndex: 0,
    color: '',
    textField: '',
    keyField: '',
    children: undefined
  };

  function deepCopy (obj) {
    return JSON.parse(JSON.stringify(obj));
  }

  var css$1 = ".fc-condition {\n    display: flex;\n}\n\n.fc-condition input {\n    width: 120px;\n}";
  styleInject(css$1);

  const Condition = ({
    fields,
    removeClick,
    onConditionValueChanged,
    value
  }) => {
    const getActiveField = conditionValue => {
      const index = fields.findIndex(field => field.name === conditionValue.field);
      const activeField = fields[index];
      const activeOperatorIndex = activeField.operators.findIndex(operator => operator.name === conditionValue.operator);
      return {
        index,
        activeOperatorIndex,
        operators: activeField.operators,
        value: conditionValue.value
      };
    };

    const updateCondition = (propertyName, newValue) => {
      const conditionValue = deepCopy(value);
      conditionValue[propertyName] = newValue;

      if (propertyName === 'field') {
        const activeField = getActiveField(conditionValue);
        conditionValue.operator = activeField.operators[0].name;
        conditionValue.value = '';
      }

      if (propertyName === 'operator') {
        conditionValue.value = '';
      }

      return conditionValue;
    };

    const handleValueChanged = e => onConditionValueChanged(updateCondition('value', e.target.value));

    const handleFieldChanged = newValue => onConditionValueChanged(updateCondition('field', newValue));

    const handleOperatorChanged = newValue => onConditionValueChanged(updateCondition('operator', newValue));

    const activeField = getActiveField(value);
    return React__default.createElement("div", {
      className: "fc-condition"
    }, React__default.createElement(Consumer, null, consumer => React__default.createElement(consumer.RemoveButton, {
      onClick: removeClick
    })), React__default.createElement(DropDownMenu, {
      textField: "name",
      keyField: "name",
      activeIndex: activeField.index,
      menuItems: fields,
      onMenuItemClick: handleFieldChanged
    }), React__default.createElement(DropDownMenu, {
      textField: "caption",
      color: "primary",
      keyField: "name",
      activeIndex: activeField.activeOperatorIndex,
      menuItems: activeField.operators,
      onMenuItemClick: handleOperatorChanged
    }), React__default.createElement(Consumer, null, consumer => React__default.createElement(consumer.Input, {
      value: activeField.value,
      onChange: handleValueChanged
    })));
  };

  Condition.propTypes = {
    removeClick: propTypes.func.isRequired,
    onConditionValueChanged: propTypes.func.isRequired,
    fields: propTypes.arrayOf(propTypes.object).isRequired,
    value: propTypes.shape({
      field: propTypes.string,
      operator: propTypes.string,
      value: propTypes.any
    }).isRequired
  };

  var css$2 = "";
  styleInject(css$2);

  const FilterGroupSettingsRow = ({
    filterValue,
    fields,
    onFilterValueChanged,
    groups,
    removeClick
  }) => {
    const onGroupMenuItemClick = newGroupName => {
      const newFilterValue = deepCopy(filterValue);
      newFilterValue.groupName = newGroupName;
      onFilterValueChanged(newFilterValue);
    };

    const getNewKey = items => items.length ? Math.max(...items.map(o => o.key)) + 1 : 0;

    const addCondition = () => {
      const newFilterValue = deepCopy(filterValue);
      const key = getNewKey(newFilterValue.items);
      const field = fields[0];
      newFilterValue.items.push({
        key,
        field: field.name,
        operator: field.operators[0].name,
        value: field.defaultValue || ''
      });
      onFilterValueChanged(newFilterValue);
    };

    const addGroup = () => {
      const newFilterValue = deepCopy(filterValue);
      const key = getNewKey(newFilterValue.items);
      const group = groups[0];
      newFilterValue.items.push({
        key,
        groupName: group.name,
        items: []
      });
      onFilterValueChanged(newFilterValue);
    };

    const onAddMenuItemClick = name => name === 'addCondition' ? addCondition() : addGroup();

    const addMenuItems = [{
      name: 'addCondition',
      caption: 'Add Condition'
    }, {
      name: 'addGroup',
      caption: 'Add Group'
    }];
    const activeIndex = groups.findIndex(g => g.name === filterValue.groupName);
    return React__default.createElement("div", {
      className: "fc-group-settings-row"
    }, removeClick && React__default.createElement(Consumer, null, consumer => React__default.createElement(consumer.RemoveButton, {
      onClick: removeClick
    })), React__default.createElement(DropDownMenu, {
      color: "secondary",
      activeIndex: activeIndex,
      textField: "caption",
      keyField: "name",
      menuItems: groups,
      onMenuItemClick: onGroupMenuItemClick
    }), React__default.createElement(Consumer, null, value => React__default.createElement(DropDownMenu, {
      textField: "caption",
      activeIndex: 1,
      keyField: "name",
      menuItems: addMenuItems,
      onMenuItemClick: onAddMenuItemClick
    }, React__default.createElement(value.AddButton, null))));
  };

  FilterGroupSettingsRow.propTypes = {
    fields: propTypes.arrayOf(propTypes.any).isRequired,
    groups: propTypes.arrayOf(propTypes.shape({
      name: propTypes.string,
      caption: propTypes.string
    })),
    filterValue: propTypes.shape({
      groupName: propTypes.string,
      items: propTypes.arrayOf(propTypes.any)
    }),
    onFilterValueChanged: propTypes.func,
    removeClick: propTypes.func
  };
  FilterGroupSettingsRow.defaultProps = {
    groups: [{
      name: 'and',
      caption: 'And'
    }, {
      name: 'or',
      caption: 'Or'
    }],
    filterValue: {
      groupName: 'and',
      items: []
    },
    onFilterValueChanged: undefined,
    removeClick: undefined
  };

  var css$3 = ".fc-group-content {\n    padding-left: 20px;\n}\n\n.fc-group .fc-group-button-icon {\n    opacity: .6;\n    font-weight: 100;\n}\n\n.fc-group .fc-group-button-icon:hover {\n    opacity: .8;\n}";
  styleInject(css$3);

  const FilterGroup = ({
    fields,
    groups,
    filterValue,
    onFilterValueChanged,
    removeClick
  }) => {
    const onItemValueChanged = (index, newValue) => {
      const newFilterValue = deepCopy(filterValue);
      newFilterValue.items[index] = newValue;
      onFilterValueChanged(newFilterValue);
    };

    const removeItem = index => {
      const newFilterValue = deepCopy(filterValue);
      newFilterValue.items.splice(index, 1);
      onFilterValueChanged(newFilterValue);
    };

    return React__default.createElement("div", {
      className: "fc-group"
    }, React__default.createElement(FilterGroupSettingsRow, {
      filterValue: filterValue,
      fields: fields,
      onFilterValueChanged: onFilterValueChanged,
      groups: groups,
      removeClick: removeClick
    }), React__default.createElement("div", {
      className: "fc-group-content"
    }, filterValue.items.map((item, index) => {
      const filterValueHandler = value => onItemValueChanged(index, value);

      const removeClickHandler = () => removeItem(index);

      return item.groupName ? React__default.createElement(FilterGroup, {
        key: item.key,
        fields: fields,
        groups: groups,
        filterValue: item,
        onFilterValueChanged: filterValueHandler,
        removeClick: removeClickHandler
      }) : React__default.createElement(Condition, {
        key: item.key,
        value: item,
        fields: fields,
        onConditionValueChanged: filterValueHandler,
        removeClick: removeClickHandler
      });
    })));
  };

  FilterGroup.propTypes = {
    fields: propTypes.arrayOf(propTypes.any).isRequired,
    groups: propTypes.arrayOf(propTypes.shape({
      name: propTypes.string,
      caption: propTypes.string
    })),
    filterValue: propTypes.shape({
      groupName: propTypes.string,
      items: propTypes.arrayOf(propTypes.any)
    }),
    onFilterValueChanged: propTypes.func,
    removeClick: propTypes.func
  };
  FilterGroup.defaultProps = {
    groups: [{
      name: 'and',
      caption: 'And'
    }, {
      name: 'or',
      caption: 'Or'
    }],
    filterValue: {
      groupName: 'and',
      items: []
    },
    onFilterValueChanged: undefined,
    removeClick: undefined
  };

  class FilterControl extends React.Component {
    constructor(props) {
      super(props);
      const {
        filterValue
      } = this.props;
      this.state = {
        filterValue
      };
      this.onFilterValueChanged = this.onFilterValueChanged.bind(this);
    }

    onFilterValueChanged(filterValue) {
      const {
        onFilterValueChanged
      } = this.props;
      this.setState({
        filterValue
      });
      onFilterValueChanged(filterValue);
    }

    render() {
      const {
        fields,
        groups
      } = this.props;
      const {
        filterValue
      } = this.state;
      return React__default.createElement("div", {
        className: "fc"
      }, React__default.createElement(FilterGroup, {
        fields: fields,
        groups: groups,
        filterValue: filterValue,
        onFilterValueChanged: this.onFilterValueChanged
      }));
    }

  }

  FilterControl.propTypes = {
    fields: propTypes.arrayOf(propTypes.any).isRequired,
    groups: propTypes.arrayOf(propTypes.shape({
      name: propTypes.string,
      caption: propTypes.string
    })),
    filterValue: propTypes.shape({
      groupName: propTypes.string,
      items: propTypes.arrayOf(propTypes.any)
    }),
    onFilterValueChanged: propTypes.func.isRequired
  };
  FilterControl.defaultProps = {
    groups: [{
      name: 'and',
      caption: 'And'
    }, {
      name: 'or',
      caption: 'Or'
    }],
    filterValue: {
      groupName: 'and',
      items: []
    }
  };

  return FilterControl;

})));
